/*
 * exer5.cpp
 *
 * Date   : October 31, 2020 (Sat.)
 * Author : Kenjiro T. MIURA, Shizuoka University, Japan
 * 
 */
#include <stdlib.h>
#include <math.h>
#include "GL/glut.h"
#include <stdio.h>

/* _ƒ_̃f[^ */
static GLdouble eye[3] = { 45.0, 45.0, 25.0 };					/*_̈ʒu*/
static GLdouble center[3] = { 0.0, 0.0, 0.0 };						/*_*/
static GLdouble up[3]; /* r[AbvxNg */

/* _̉]p */
static int spin_eye = 0;

static int globalWidth;
static int globalHeight;

/* _̐ւ̉] */
void 
rotEyePlus(void)
{
    spin_eye = ( spin_eye + 15 ) % 360;				/*PT*/
}

/* _̕ւ̉] */
void 
rotEyeMinus(void)
{
    spin_eye = ( spin_eye - 15 ) % 360;				/*PT*/
}
static int projection=1;

/*̂̕`*/
void 
drawCube() {
	float vertex[8][3]={{0.,0.,0.},{10.,0.,0.},{10.,10.,0.},{0.,10.,0.},
	{0.,0.,10.},{10.,0.,10.},{10.,10.,10.},{0.,10.,10.}};
	int i;

	glBegin(GL_LINE_LOOP);
	for(i=0;i<4;++i){
		glVertex3fv(vertex[i]);
	}
	glEnd();

	glBegin(GL_LINE_LOOP);
	for(i=0;i<4;++i){
		glVertex3fv(vertex[i+4]);
	}
	glEnd();

	glBegin(GL_LINES);
	for(i=0;i<4;++i){
		glVertex3fv(vertex[i]);
		glVertex3fv(vertex[i+4]);
	}
	glEnd();
}

/* W̕` */
void 
drawAxis() {
  /* x(bh) */
  glColor3f(1.0f, 0.0f, 0.0f);
  glBegin(GL_LINES);
    glVertex3f(-100.0f, 0.0f, 0.0f);
    glVertex3f(100.0f, 0.0f, 0.0f);
  glEnd();

  /* y(O[) */
  glColor3f(0.0f, 1.0f, 0.0f);
  glBegin(GL_LINES);
    glVertex3f(0.0f, -100.0f, 0.0f);
    glVertex3f(0.0f, 100.0f, 0.0f);
  glEnd();

  /* z(u[) */
  glColor3f(0.0f, 0.0f, 1.0f);
  glBegin(GL_LINES);
    glVertex3f(0.0f, 0.0f, -100.0f);
    glVertex3f(0.0f, 0.0f, 100.0f);
  glEnd();
}

void
ourDisplay(void)
{
  /* obt@̃NA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  /* fr[s */
  glMatrixMode ( GL_MODELVIEW );
  glLoadIdentity ();
  /* r[sZbgB*/    
  gluLookAt(eye[0], eye[1], eye[2], center[0], center[1], center[2],
            up[0], up[1], up[2]);									/*_̐ݒi_A_Aj*/

  /* _̉]ړ	 */
  glRotated ( (GLdouble) spin_eye, 0.0, 0.0, 1.0 );					/*z̕spin_eyex]*/

  glColor3f(1.,1.,1.);
  glLineWidth(2.);
  drawCube();										/* drawCube() Ăяo@*/

  /* x, y, z̕` */
  drawAxis();		

  glFlush();
}

void 
ourInit (void) 
{
  glClearColor(0.0, 0.0, 0.0, 1.0);		/*wiF̎w*/
  glDepthFunc ( GL_LESS );				/*fvXeXĝ߂̔r֐GL_LESSiÕtOg`j*/
  glEnable ( GL_DEPTH_TEST );			/*fvXeXgLɂ*/
}

/*
 *  EChEŏɃI[vEChEړ⃊TCYꂽ
 *  Ă΂B
 */
void 
ourReshape(int width, int height)
{
    int i; /* JE^[ */
    GLdouble vector[3]; /* r[AbvxNgvZpxNg */
    GLdouble norm; /* xNg̃m */

	globalWidth=width;
	globalHeight=height;

    glViewport (0, 0, width, height);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity();

	if(projection==2){
		gluPerspective(80.0, (GLfloat) width/(GLfloat) height, 0.1, 1000.0);
	}
	else{
		glOrtho(-50.,50.,-50.*(GLfloat) height/(GLfloat) width,50.*(GLfloat) height/(GLfloat) width,-100.,1000.);
	}
	
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    /* r[AbvxNgvZB*/
    for ( i=0; i<3; i++ ){
        vector[i] = center[i] - eye[i];
    }
    up[0] = - vector[0] * vector[2];
    up[1] = - vector[1] * vector[2];
    up[2] = vector[0] * vector[0] + vector[1] * vector[1];
    norm = up[0] * up[0] + up[1] * up[1] + up[2] * up[2];
    norm = sqrt ( norm );

    for ( i=0; i<3; ++i ) up[i] /= norm;
}

void main_menu(int value)					/* Cj[ */
{
    switch(value){
    case 999:
		exit(1);
		break;
	}
	glutPostRedisplay();
}

void Rotate(int value)						/*@_]@*/
{
	switch(value){
	case 1:
		rotEyePlus();
		break;
	case 2:
		rotEyeMinus();
		break;
	}
	glutPostRedisplay();
}

void Projection(int value)					/*@eϊ@*/
{
	switch(value){
	case 3:
		projection=1;
		ourReshape(globalWidth,globalHeight);
		break;
	case 4:
		projection=2;
		ourReshape(globalWidth,globalHeight);
		break;
	}
	glutPostRedisplay();
}

/*  C */
int 
main(int argc, char **argv) 
{
	int submenu1,submenu2;

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize(400, 400);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("exer5");
	ourInit();
	glutReshapeFunc(ourReshape);
	glutDisplayFunc(ourDisplay);

	submenu1=glutCreateMenu(Rotate);					/*	Rotate eye ̃Tuj[̍쐬 */
	glutAddMenuEntry("positive",1);
	glutAddMenuEntry("negative",2);

	submenu2=glutCreateMenu(Projection);				/* Prjection ̃Tuj[̍쐬 */
	glutAddMenuEntry("Ortho",3);
	glutAddMenuEntry("Perspective",4);
	
	glutCreateMenu(main_menu);							/* Cj[ */
	glutAddSubMenu("Rotation mode",submenu1);
	glutAddSubMenu("Projection Mode",submenu2);         /* Projection Mode ̍쐬 */
    glutAddMenuEntry("Exit",999);						/* Exit ̍쐬 */
    glutAttachMenu(GLUT_RIGHT_BUTTON);					/* }EXENbNŃ|bvAbvj[ */

	glutMainLoop();
	return 0;

}



